program moc

   implicit none
   
   integer, parameter                  :: ND=116, HH=4, NVARp=15, NVARo=2, PER=21
   integer                             :: i, j,nv

   real                                :: mediax, mediay, varx, vary
   real                                :: covarxy 
   real, dimension(ND)                 :: x, y
   real, dimension(NVARp)              :: correlxy
   real, dimension(ND, NVARp)          :: prev
   real, dimension(ND, NVARo)          :: obs

   character(len=5), dimension(NVARp)  :: varp
   character(len=5), dimension(NVARo)  :: varo
   
   

!  Input data: previsao -----------------------------------------------   
   open(10, file='../datain/previsao.txt')

   do j=1, NVARp
      read(10, *) varp(j), (prev(i, j), i=1, ND)
   enddo

   
!  observacao: -------------------------------------------------------   
   open(11, file='../datain/obs.txt')
   
   do j=1, NVARo
      read(11, *) varo(j), (obs(i, j), i=1, ND)
   enddo
      

!--------------------------------------------------------------------------------------------
!  Esquema de armazenamento das variaveis:
!  
!  prev(ND, NVARp) ::  ND    :: numero de horarios dos dias corridos
!                          NVARp :: numero de variaveis: 1->10u, 2->10v, ..., 15->ultimavar
!
!--------------------------------------------------------------------------------------------


!--------------------------------------------------------------------------------------------
!  1a tentativa: calcular u e v separadamente 
!  2a          : calcular o vento u;v
!XX3a          : calcular para os horarios separados: 00, 00, ...  deu ruim (correl baixa)
!  4a          : calcular para os horarios corridos: 00, 06, 12, ...


!  X :: vars independentes y(x)=x1...  previsoes
!  Y :: var dependente                 obs 
!--------------------------------------------------------------------------------------------

  correlxy=0.0
  do nv=1, NVARp

     x=prev(:, nv)
     y=obs(:, 1)



!     -------------------------
!     media:   
!
      mediax = sum(x)/ND
      mediay = sum(y)/ND





!     -------------------------
!     variancia:   
!
      varx = sum((x - mediax) * (x - mediax))
      vary = sum((y - mediay) * (y - mediay))




!     -------------------------
!     covariancia:   
!
      covarxy = sum((x - mediax) * (y - mediay))




!     -------------------------
!     correlacao:   
!
      correlxy(nv)=covarxy/sqrt(varx)/sqrt(vary)
   

!      open(20, file='../dataout/serie.bin', access='direct', form='unformatted', status='unknown', recl=2*4)
!
      do i=1, ND
         print*, i, y(i), x(i)
!         write(20, rec=i) prev(i, 1), obs(i, 1)
      enddo
   
   
   enddo   
   
      print*, correlxy
   

      
   

end program moc
